// C:\Program Files (x86)\Alaska Software\workbench20;C:\Bat;C:\Alaska\bdms\bin;C:\Alaska\Bdms\Lib;C:\Alaska\Exp\Bin20;C:\Program Files (x86)\Advantage 10.10\arc;C:\Program Files (x86)\Alaska Software\xpp20\bin;C:\Program Files (x86)\Alaska Software\cxp20\bin;C:\Program Files (x86)\Alaska Software\xpp20\lib;C:\Alaska\tracker;C:\Alaska\xb2net;C:\Me2008;C:\Alaska\CrstlCOMM;C:\Program Files\Intel\WiFi\bin\;C:\Program Files\Common Files\Intel\WirelessCommon\
#INCLUDE "APPEVENT.CH"
#INCLUDE "XBP.CH"

#INCLUDE "DCDIALOG.CH"
#INCLUDE "DCPRINT.CH"

#INCLUDE "BDMSLIB.CH"
#INCLUDE "BDCOLORS.CH"

#INCLUDE "class.ch"

*#DEFINE ACTIVE_TAB(oTab)  !oTab:minimized

#DEFINE SKEY_ROOT_ENVIRONMENT    'Environment'
#DEFINE SKEY_SYSTEM_ENVIRONMENT  'SYSTEM\CurrentControlSet\Control\Session Manager\Environment'
#DEFINE SKEY_PATH                'Path'
#DEFINE SKEY_LIB                 'Lib'
#DEFINE SKEY_INCLUDE             'Include'

/// defines for the environment array
#DEFINE ENV_PATH              1
#DEFINE ENV_LIB               2
#DEFINE ENV_INCLUDE           3

/// defines for the environment array
#DEFINE ENV_SYSTEM            1
#DEFINE ENV_USER              2
#DEFINE ENV_CURRENT           3


/// defines for the tabs
#DEFINE TAB_PATH              1
#DEFINE TAB_LIB               2
#DEFINE TAB_INCLUDE           3

#DEFINE TAB_PARENT            1
#DEFINE TAB_SYSTEM            2
#DEFINE TAB_USER              3
#DEFINE TAB_CURRENT           4

#DEFINE BATCH_REPLACE         1
#DEFINE BATCH_APPEND          2

*#DEFINE CR_LF    Chr(13)+Chr(10)

STATIC scFocus := "PATH_SYSTEM"

*--------------------------------------

FUNCTION Main

LOCAL oPathUtil := PathUtil():new()

RETURN oPathUtil:buildScreen()

* ---------

PROC appsys ; RETURN

* ---------

CLASS PathUtil

EXPORTED:

VAR GetList
VAR buttonConfig
VAR browseObject
VAR dialogWindow
VAR tabArray
VAR fileArray
VAR envirArray
VAR batFileArray
VAR multiObjArray

METHOD Init, BuildScreen, SelectTab, BuildTabs, GetEnvironmentStr, SearchFile, ;
       SaveEnvironment, WriteEnvironmentBatch, ViewBatchFiles, SelectFile, ;
       ButtonConfig, OpenFile, ReadFile, GetFileName, IsBatchFile, ;
       AnchorFocus, AnchorCargo, MarkText, RClickMenu, FileNames, ;
       DrawCellHighlighted, DeleteFile

ENDCLASS

* -----------

METHOD PathUtil:init()

::buttonConfig := ::buttonConfig()
::tabArray := {{,,,},{,,,},{,,,}}
::fileArray := {{"","",{,,,,,,,,,}}}
::envirArray := {{"","",""},{"","",""},{"","",""}}
::batFileArray := {{},{},{}}
::multiObjArray := {{,,},{,,},{,,}}

RETURN self

* -----------

METHOD PathUtil:BuildScreen()

LOCAL GetList[0], GetOptions
LOCAL cFileName := Space(30)
LOCAl nPtr
LOCAL oPathTab, oLibTab, oIncludeTab, oStatic, oBrowseStatic, oFontLarge, oBitMap
LOCAL oPopMenu, oDropBrowse, oFileName, oMenuBar, oFileMenu
LOCAL aNames := {}
LOCAL bOwnerDraw
LOCAL cHighlight := Space(10)

::getList := GetList

oFontLarge := XbpFont():new():create('14.CALIBRI Bold Italic')
bOwnerDraw := {|a,b|::DrawCellHighlighted(a,b,Alltrim(cHighLight),oFontLarge,oBitmap)}

aNames := ::FileNames()

@   0.00,  0.00 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oStatic SIZE 150.80,33.30 ;
                RESIZE DCGUI_RESIZE_RESIZEONLY

@   0.00,  0.30 DCSAY "Search" ;
                SAYLEFTCENTER SAYSIZE 6 TABSTOP PARENT oStatic ;
                SAYTOOLTIP "The File Name To Search For In The Environment Settings" ;
                RESIZE DCGUI_RESIZE_REPOSONLY_Y

@   0.80,  0.30 DCGET cFileName ;
                PARENT oStatic ;
                RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
                VALID {|| IIF( ::SearchFile(@cFileName), ;
                          (::browseObject:refreshAll(), SetAppFocus(::browseObject)),nil)} ;

@   1.70,  0.30 DCBROWSE oDropBrowse DATA aNames SIZE 35, 6 ;
                FONT '10.Lucida Console' ;
                FILTER {|a|a[2]} ;
                ITEMSELECTED {|a,b,o| IIF(o:isVisible(), ;
                                          (cFileName := Pad(aNames[oDropBrowse:arrayElement,1],30), ;
                                           oFileName:setData(cFileName),o:hide()),nil)} ;
                LOSTFOCUS {|a,b,o|o:hide()} ;
                NOHSCROLL ;
                USEVISUALSTYLE

DCBROWSECOL ELEMENT 1 WIDTH 30 PARENT oDropBrowse


@   2.30,  0.30 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oBrowseStatic SIZE 150.00, 7.20 ;
                PARENT oStatic RESIZE DCGUI_RESIZE_RESIZEX_REPOSY

@   0.30,  0.50 DCBROWSE ::browseObject DATA ::fileArray PARENT oBrowseStatic SIZE 149.50, 6.80 ;
                RBSELECT OWNERDRAW bOwnerDraw ;
                RESIZE DCGUI_RESIZE_RESIZEONLY ;
                PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },;                    /// Header FG Color
                               { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND },;               /// Header BG Color
                               { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },;                   /// Footer FG Color
                               { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },;                 /// Footer BG Color
                               { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },;                    /// Cell FG Color
                               { XBP_PP_COL_DA_BGCLR, GraMakeRGBColor({250,250,250})},;    /// Cell BG Color
                               { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLACK },;             /// Cell Highlighted FG
                               { XBP_PP_COL_DA_HILITE_BGCLR, BD_IVORY },;                  /// Cell Highlighted BG
                               { XBP_PP_COL_HA_FRAMELAYOUT, HDR_FLAT_NOFRAME_CLEAR},;      /// no frame, no lines, no colors
                               { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },;         /// row sep
                               { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },;         /// Col Sep
                               { XBP_PP_COL_DA_CELLFRAMELAYOUT,  2 },;                     /// Cell Frame Layout
                               { XBP_PP_COL_DA_COLSEPARATOR, 1 },;                         /// Column Separator
                               { XBP_PP_COL_DA_FRAMELAYOUT, 6 },;                          /// Frame Layout
                               { XBP_PP_COL_DA_ROWHEIGHT, 20 },;                           /// Row Height
                               { XBP_PP_COL_DA_CELLHEIGHT, 20 }} ;                         /// Cell Height
                POINTER nPtr ;
                HEADPRES {{ XBP_PP_COMPOUNDNAME, '8.Arial' }} ;
                SORTSCOLOR GRA_CLR_BLACK,BD_WHEAT ;
                SORTUCOLOR GRA_CLR_BLACK,BD_SANDYBROWN ;
                SORTNONCOLOR GRA_CLR_BLACK,BD_ICEGREEN ;
                ITEMMARKED {|| ::browseObject:invalidateRect(), ;
                               ::selectTab(::fileArray[nPtr,2])} ;
                CURSORMODE XBPBRW_CURSOR_ROW ;
                FONT '12.Arial' ;
                SCROLLBARHEIGHT 10

                DCBROWSECOL HEADER "Folder Name" OWNERDRAW ;
                DATA {|| ::fileArray[::browseObject:arrayElement][1]} WIDTH 39 PARENT ::browseObject PROTECT {||.t.} ;
                TOOLTIP "File Name Location"

                DCBROWSECOL HEADER "Environment" OWNERDRAW ;
                DATA {|| ::fileArray[::browseObject:arrayElement][2]} WIDTH 10 PARENT ::browseObject PROTECT {||.t.} ;
                TOOLTIP "Environment Setting"

                DCBROWSECOL HEADER "Size" ;
                DATA {|| ::fileArray[::browseObject:arrayElement][3,2]} WIDTH 6 PARENT ::browseObject PROTECT {||.t.} ;
                TOOLTIP "File Size"

                DCBROWSECOL HEADER "Date" ;
                DATA {|| ::fileArray[::browseObject:arrayElement][3,3]} WIDTH 6 PARENT ::browseObject PROTECT {||.t.} ;
                TOOLTIP "File Date"

                DCBROWSECOL HEADER "Time" ;
                DATA {|| ::fileArray[::browseObject:arrayElement][3,4]} WIDTH 6 PARENT ::browseObject PROTECT {||.t.} ;
                TOOLTIP "File TIme"


/// PATH TAB PAGE
@  10.00,  0.00 DCTABPAGE ::tabArray[TAB_PATH,TAB_PARENT] PARENT oStatic ;
                CAPTION 'Path' ;
                ;// EVAL {|| oPathTab:useVisualStyle := .T. } ;
                TABWIDTH 15 TABHEIGHT 21 SIZE 150.85,023.00 ANGLE 45 ;
                GOTFOCUS {|| DC_GetRefresh(GetList,,,,'BUTTONS')} ;
                ;//COLOR BD_LEDGERBLUE2 ;
                COLOR BD_OUTLOOKRIBLIGHT ;
                MAXIMIZEDCOLOR GRA_CLR_BLACK,BD_MICROSOFTGREY ;
                ID 'PATHTAB' ;
                RESIZE DCGUI_RESIZE_RESIZEONLY

/// LIB TAB PAGE
@  00.00,  0.00 DCTABPAGE ::tabArray[TAB_LIB,TAB_PARENT] PARENT oStatic ;
                CAPTION 'Lib' RELATIVE ::tabArray[TAB_PATH,TAB_PARENT] ;
                GOTFOCUS {|| DC_GetRefresh(GetList,,,,'BUTTONS')} ;
                COLOR BD_LEDGERGREEN1 ;
                MAXIMIZEDCOLOR GRA_CLR_BLACK,BD_PALEYELLOW;
                ID 'LIBTAB' ;
                RESIZE DCGUI_RESIZE_RESIZEONLY


/// INCLUDE TAB PAGE
@  00.00,  0.00 DCTABPAGE ::tabArray[TAB_INCLUDE,TAB_PARENT] PARENT oStatic ;
                CAPTION 'Include' RELATIVE ::tabArray[TAB_LIB,TAB_PARENT] ;
                GOTFOCUS {|| DC_GetRefresh(GetList,,,,'BUTTONS')} ;
                COLOR BD_PALEYELLOW ;
                MAXIMIZEDCOLOR GRA_CLR_BLACK,BD_MICROSOFTGREY ;
                ID 'INCLUDETAB' ;
                RESIZE DCGUI_RESIZE_RESIZEONLY

DCMENUBAR oMenuBar

  DCSUBMENU oFileMenu  PARENT oMenuBar  PROMPT "&File"
    DCMENUITEM "&Open" ;
      PARENT oFileMenu ;
      ACTION {|| ::OpenFile() }

    DCMENUITEM "&Exit" ;
      PARENT oFileMenu ;
      ACTION {|| _quit()}


/// Right Click
DCSUBMENU oPopMenu PROMPT "Options" PARENT ::browseObject
  DCMENUITEM "Delete File" PARENT oPopMenu ;
  ACTION {|| ::DeleteFile( nPtr) } ;
  TOOLTIP "Removes The File From The Hard Drive"

::BuildTabs()


@  34.00,  0.00 DCPUSHBUTTONXP  CAPTION "D&one" ;
                ACCELKEY xbeK_ALT_O SIZE 12,1.4 GROUP 'BUTTONS' CONFIG ::ButtonConfig ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
                TOOLTIP "Exit"

@  34.00, 13.00 DCPUSHBUTTONXP ;
                CAPTION {|| IIF( ACTIVE_TAB(::tabArray[TAB_PATH,TAB_SYSTEM]),  "Set;System Path", ;
                            IIF( ACTIVE_TAB(::tabArray[TAB_PATH,TAB_USER]),    "Set;User Path",;
                            IIF( ACTIVE_TAB(::tabArray[TAB_PATH,TAB_CURRENT]), "Save;Current Path","")))} ;
                ACCELKEY xbeK_ESC SIZE 12,1.4 GROUP 'BUTTONS' CONFIG ::ButtonConfig ;
                ACTION {|| ::SaveEnvironment()} ;
                TOOLTIP "Save Path Data"

@  34.00, 28.00 DCPUSHBUTTONXP ;
                CAPTION "View;Batch Files" ;
                HIDE {||  ::isBatchFile() } ;
                ACCELKEY xbeK_ESC SIZE 12,1.4 GROUP 'BUTTONS' CONFIG ::ButtonConfig ;
                ACTION {|| ::ViewBatchFiles()} ;
                TOOLTIP "Save Path Data"


DCGETOPTIONS ;
    TITLE "Path Utility" ;
    TABSTOP ;
    CASCADE ;
    RESIZE ;
    HILITEGETS BD_TEAL ;
    TOOLTIPCOLOR BD_BLACK,BD_PALEYELLOW

DCREAD GUI OPTIONS GetOptions FIT SETAPPWINDOW ;
  EVAL {|o| ::dialogWindow := o, ;
            ::RClickMenu(@oPopMenu, 1, 5 ), ;
            oDropBrowse:hide(), ;
            DC_GetRefresh(GetList,,,,'BUTTONS')}

RETURN self

*-------------

METHOD PathUtil:isBatchFile()

LOCAL lReturn := .T.

IF scFocus = "PATH_CURRENT" .AND. !Empty(::batFileArray[ENV_PATH])
  lReturn := .F.
ELSEIF scFocus = "LIB_CURRENT" .AND. !Empty(::batFileArray[ENV_LIB])
  lReturn := .F.
ELSEIF scFocus = "INCLUDE_CURRENT" .AND. !Empty(::batFileArray[ENV_INCLUDE])
  lReturn := .F.
ENDIF

RETURN lReturn

* ----------

METHOD PathUtil:selectTab(cType)

LOCAL i, nTab, nSubTab, nEnvTab, nEnvStr

IF !Empty(cType)                                                            /// cType is the Id in the array indicating if the file is in the path, lib or include environment
  IF scFocus # cType                                                        /// does the tab group in focus does not match the id in the highlighted array item
    nTab := IIF( cType = "PATH", TAB_PATH, IIF( cType = "LIB", TAB_LIB, TAB_INCLUDE))
    DC_TabActivate(::tabArray[nTab,TAB_PARENT])                                  /// acitivate the correct main tab

    FOR nEnvStr := ENV_SYSTEM TO ENV_CURRENT                                /// loop through the sub tabs to see which should be activated
       IF !Empty(::envirArray[nTab, nEnvStr])                                       /// make sure there is data in the environment string
         DC_TabActivate(::tabArray[nTab,nEnvStr+1])
         EXIT
       ENDIF
    NEXT
  ENDIF
ENDIF

RETURN nil

* ---------

METHOD PathUtil:BuildTabs()

LOCAL cId, nColor, nTab, nSubTab, nEnv, cTitle, GetList := ::getList

FOR nTab := TAB_PATH TO TAB_INCLUDE

   nEnv := IIF( nTab = TAB_PATH, ENV_PATH, IIF( nTab = TAB_LIB, ENV_USER, ENV_CURRENT))
   cId := IIF( nTab = TAB_PATH, "PATH_", IIF( nTab = TAB_LIB, "LIB_", "INCLUDE_"))
   nColor := IIF( nTab = TAB_PATH, BD_OUTLOOKRIBLIGHT, IIF( nTab = TAB_LIB, BD_LEDGERGREEN1, BD_PALEYELLOW ))

   ::GetEnvironmentStr(nEnv)

   FOR nSubTab := TAB_SYSTEM TO TAB_CURRENT

      cTitle := IIF( nSubTab = TAB_SYSTEM, "System", IIF( nSubTab = TAB_USER, "User", "Current"))

      IF nSubTab = TAB_SYSTEM
        @   1.00,  0.00 DCTABPAGE ::tabArray[nTab,nSubTab] PARENT ::tabArray[nTab,TAB_PARENT] ;
                        CAPTION cTitle ;
                        TABWIDTH 12 TABHEIGHT 20 SIZE 150.80,022.00 ANGLE 00 ;
                        GOTFOCUS ::AnchorFocus(cId, cTitle, nEnv,nSubTab-1) ;
                        COLOR nColor ;
                        MAXIMIZEDCOLOR GRA_CLR_BLACK,BD_MICROSOFTGREY ;
                        ID cId+Upper(cTitle) ;
                        RESIZE DCGUI_RESIZE_RESIZEONLY
      ELSE
        @   0.00,  0.00 DCTABPAGE ::tabArray[nTab,nSubTab] PARENT ::tabArray[nTab,TAB_PARENT] ;
                        CAPTION cTitle ;
                        RELATIVE ::tabArray[nTab, nSubTab-1] ;
                        GOTFOCUS ::AnchorFocus(cId, cTitle, nEnv,nSubTab-1) ;
                        COLOR nColor ;
                        MAXIMIZEDCOLOR GRA_CLR_BLACK,BD_MICROSOFTGREY ;
                        ID cId+Upper(cTitle) ;
                        RESIZE DCGUI_RESIZE_RESIZEONLY
      ENDIF

      @   1.40,  1.10 DCMULTILINE ::envirArray[nEnv,nSubTab-1] SIZE 148.30, 20.20 ;
                      OBJECT ::multiObjArray[nEnv,nSubTab-1] PARENT ::tabArray[nTab,nSubTab] FONT "12.Courier New" TABSTOP ;
                      EVAL ::AnchorCargo(nEnv, nSubTab)
   NEXT

NEXT

RETURN nil

* -----------

METHOD PathUtil:AnchorFocus(cId, cTitle, nEnv, nSubTab)

RETURN {|| DC_GetRefresh(::getList,,,,'BUTTONS'), ;
           ::MarkText(::multiObjArray[nEnv,nSubTab]), ;
           scFocus := cId+Upper(cTitle)}

* -----------

METHOD PathUtil:AnchorCargo(nEnv, nSubTab)

RETURN {|o|DC_GetCargo(o,::envirArray[nEnv,nSubTab-1])}

* ----------

METHOD PathUtil:MarkText( oMle )

LOCAL cFileName, cMle, cPath, nStart, nEnd

cFileName := ::browseObject:dataSource[::browseObject:arrayElement,1]
cMle := DC_GetCargo(oMle)
cPath := DC_Path(cFileName)
cPath := Substr(cPath,1,Len(cPath)-1)
cMle := Strtran(cMle, cPath, cPath + '  ' + Repl(Chr(17),50))
oMle:setData(cMle)

RETURN nil

* -----------

METHOD PathUtil:GetEnvironmentStr(nType)

LOCAL cStr, cKey, i, j, aPaths

IF nType = ENV_PATH
  cKey := SKEY_PATH
ELSEIF nType = ENV_LIB
  cKey := SKEY_LIB
ELSE
  cKey := SKEY_INCLUDE
ENDIF

FOR i := ENV_SYSTEM TO ENV_CURRENT
   IF i = ENV_SYSTEM
     cStr := DC_RegQuery(HKEY_LOCAL_MACHINE, SKEY_SYSTEM_ENVIRONMENT, cKey)
   ELSEIF i = ENV_USER
     cStr := DC_RegQuery(HKEY_CURRENT_USER, SKEY_ROOT_ENVIRONMENT, cKey)
   ELSE
     cStr := GetEnv(cKey)
   ENDIF

   aPaths := DC_TokenArray(cStr,";")
   FOR j := 1 TO Len(aPaths)
      ::envirArray[nType,i] += aPaths[j]
      IF j < Len(aPaths)
        ::envirArray[nType,i] += CR_LF
      ENDIF
   NEXT
NEXT

RETURN nil

* -----------

METHOD PathUtil:SearchFile(cFile)

LOCAL cFileName, cFileDir, cFilePath, i, nPointer, nLength := 0
LOCAL aDir, aFilePath, aEnv := {"PATH","LIB","INCLUDE"}
LOCAl lReturn := .T.

IF !Empty(cFile)

  cFileName := Alltrim(cFile)
  ASize(::fileArray, 0)

  FOR i := 1 TO Len(aEnv)

     cFilePath := GetEnv(aEnv[i])

     DO WHILE .t.
       nPointer := AT(';',cFilePath)
       cFileDir := ''
       IF nPointer > 0
         cFileDir := Alltrim(SubStr( cFilePath, 1, nPointer-1 )) + '\'
         IF File( cFileDir+cFileName )
           nLength := Max(Len(cFileDir+cFileName),nLength)
           aDir := Directory(cFileDir+cFileName)
           AAdd(::fileArray, {cFileDir + cFileName, aEnv[i], aDir[1] })
         ENDIF
         cFilePath := SubStr( cFilePath, nPointer + 1 )
       ELSE
         cFileDir := Alltrim(cFilePath) + '\'
         IF !File(cFileDir+cFileName)
           cFileDir := ''
         ENDIF
         EXIT
       ENDIF
     ENDDO
  NEXT

  IF Empty(::fileArray)
    DCMSGBOX "The File: " + cFileName, ;
             "Was not Found In The 'Path', 'Lib' or 'Include' Environment Settings" ;
             TIMEOUT 3
    lReturn := .F.
  ENDIF

ENDIF

RETURN lReturn

* ----------

METHOD PathUtil:SaveEnvironment()

LOCAL cFile, cKey, cFileName := PadR("*.bat", 40 ), i, nTab, nHndle, nChoice, nEvent := 0

nTab := IIF( scFocus = "PATH", TAB_PATH, IIF( scFocus = "LIB", TAB_LIB, TAB_INCLUDE))
cKey := IIF( scFocus = "PATH", SKEY_PATH, IIF( scFocus = "LIB", SKEY_LIB, SKEY_INCLUDE))

IF ACTIVE_TAB(::tabArray[nTab,TAB_SYSTEM])                                     /// system tab
  ::envirArray[nTab,ENV_SYSTEM] := StrTran(::envirArray[nTab,ENV_SYSTEM], CR_LF, ";")
  DC_RegWrite(HKEY_CURRENT_USER, SKEY_SYSTEM_ENVIRONMENT, cKey, ::envirArray[nTab,ENV_SYSTEM])
  DCMSGBOX "System Environment Saved!" TIMEOUT 3

ELSEIF ACTIVE_TAB(::tabArray[TAB_PATH,TAB_USER])

  ::envirArray[nTab,ENV_USER] := StrTran(::envirArray[nTab,ENV_USER], CR_LF, ";")
  DC_RegWrite(HKEY_CURRENT_USER, SKEY_ROOT_ENVIRONMENT, cKey, ::envirArray[nTab,ENV_USER])
  DCMSGBOX "User Environment Saved!" TIMEOUT 3

ELSEIF ACTIVE_TAB(::tabArray[TAB_PATH,TAB_CURRENT])

  ::getFileName(@cFileName)
  cFile := Alltrim(cFileName)

  IF FExists(cFile)
    DCMSGBOX "File: " + cFile + " Already Exists", "Replace?" ;
    TITLE "File Alert" ;
    BUTTONS {"Replace", "Append", "Cancel"} ;
    CHOICE @nChoice

    IF nChoice = 1
      FErase(cFile)
      ::WriteEnvironmentBatch(cFile, ::envirArray[nTab,ENV_CURRENT], scFocus, BATCH_REPLACE)
    ELSEIF nChoice = 2
      ::WriteEnvironmentBatch(cFile, ::envirArray[nTab,ENV_CURRENT], scFocus, BATCH_APPEND)
    ENDIF
  ELSE
    ::WriteEnvironmentBatch(cFile, ::envirArray[nTab,ENV_CURRENT], scFocus)
  ENDIF
ENDIF

RETURN nil

* -----------

METHOD PathUtil:WriteEnvironmentBatch(cFileName, cString, cType, nEvent)

   LOCAL cPreStr, nHndle, nType

   IF nEvent = BATCH_REPLACE
     FErase(cFileName)
   ELSEIF nEvent = BATCH_APPEND
     nHndle := FOpen(cFileName)
     cPreStr := FReadStr(nHndle, 10000)
     FCLose(nHndle)
   ENDIF

   nHndle := FCreate(cFileName)
   IF nHndle > 0
     cString := StrTran(cString, CR_LF, ";")
     IF Empty(cPreStr)
       FWrite(nHndle, "REM Environment Batch File Created By PathUtil.Exe On " + DTOC(Date()) + CR_LF)
     ELSE
       FWrite(nHndle, cPreStr)
     ENDIF
     FWrite(nHndle, " " + CR_LF)
     FWrite(nHndle, "SET " + cType + "=%"+ cType + "%;")
     FWrite(nHndle, cString)
     FClose(nHndle)
     DCMSGBOX cFileName + " Saved!" TIMEOUT 3

     nType := IIF( cType = "PATH_CURRENT", ENV_PATH, IIF( cType = "LIB_CURRENT", ENV_LIB, ENV_INCLUDE))
     IF AScan(::batFileArray[nType], {|a| Upper(a) = Upper(cFileName)} ) = 0
       Aadd(::batFileArray[nType], {cFileName})
     ENDIF
  ENDIF

return nil

*-------------

METHOD PathUtil:ViewbatchFiles()

LOCAL GetList[0], GetOptions
LOCAL cFileName, cStr, nType, oBrowse, oConfig, oThread

nType := IIF( scFocus = "PATH_CURRENT", ENV_PATH, IIF( scFocus = "LIB_CURRENT", ENV_LIB, ENV_INCLUDE))

IF Len(::batFileArray[nType]) = 1
  cFileName := ::batFileArray[nType,1,1]

ELSE
  cFileName := ::SelectFile(::dialogWindow, ::batFileArray[nType])

ENDIF

IF !Empty(cFileName)
  oThread:=Thread():new()
  oThread:Start( {|| ::ReadFile(cFileName)})
ENDIF

return nil

* -----------

METHOD PathUtil:SelectFile()

LOCAL GetList[0], GetOptions
LOCAL oBrowse, oDimDlg, nPtr

oDimDlg := dc_DimScreen(::dialogWindow)

@   0.00,  0.00 DCBROWSE oBrowse DATA ::fileArray FIT ;
                SIZE 30, 8 ;
                POINTER nPtr ;
                PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },;                           ///  Header FG Color
                               { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND },;                      ///  Header BG Color
                               { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },;                          ///  Footer FG Color
                               { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },;                        ///  Footer BG Color
                               { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },;                           ///  Cell FG Color
                               { XBP_PP_COL_DA_BGCLR, GraMakeRGBColor({249,246,210})},;           ///  Cell BG Color
                               { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLACK },;                    ///  Cell Highlighted FG
                               { XBP_PP_COL_DA_HILITE_BGCLR, GraMakeRGBColor({255,228,196}) },;   ///  Cell Highlighted BG
                               { XBP_PP_COL_DA_HILITEFRAMELAYOUT,BD_VERYTHICK_RECESSED},;         ///  Cell outline
                               { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },;                ///  row sep - no lines
                               { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },;                ///  Col Sep - no lines
                               { XBP_PP_COL_DA_CELLFRAMELAYOUT ,  2 },;                           ///  Cell Frame Layout - no lines
                               { XBP_PP_COL_DA_COLSEPARATOR  ,    1 },;                           ///  Column Separator - no lines
                               { XBP_PP_COL_DA_FRAMELAYOUT  ,     0 },;                           ///  Frame Layout - no lines
                               { XBP_PP_COL_HA_FRAMELAYOUT,XBPFRAME_BOX },;                       /// removes dividing lines from headers
                               { XBP_PP_COL_DA_ROWHEIGHT, -1 },;                                  ///  Row Height
                               { XBP_PP_COL_DA_CELLHEIGHT, 16 } } ;                               ///  Cell Height
                HEADPRES {{ XBP_PP_COMPOUNDNAME, '7.Arial' }} ;
                ITEMSELECTED {|| .T. }  ;
                FONT "12.Arial"

                DCBROWSECOL HEADER "Batch File Name" ;
                  ELEMENT 1 WIDTH 20 PARENT oBrowse

DCREAD GUI TITLE "Choose File" OPTIONS GetOptions ADDBUTTONS FIT ENTEREXIT MODAL SETAPPWINDOW ;
       SETFOCUS @oBrowse

oDimDlg:destroy()

RETURN ::fileArray[nPtr,1]

* ----------

METHOD PathUtil:DeleteFile(nPtr)

IF FExists(::fileArray[nPtr,1])
  IF Ferase(::fileArray[nPtr,2]) == 0
    DCMSGBOX "File Deleted!" TIMEOUT 3
  ELSE
    DCMSGBOX "File Could Not Be Deleted!","Error Code: " + Str(FError())
  ENDIF
ELSE
  DCMSGBOX "File Not Found!" TIMEOUT 3
ENDIF

RETURN nil

*---------

METHOD PathUtil:GetFileName(cFileName)

LOCAL GetList[0], GetOptions

@   0.00,  0.00 DCSAY "Batch File Name" ;
                GET cFileName ;
                SAYSIZE 15 SAYRIGHTCENTER ;
                POPUP {|c| DC_PopFile(cFileName, "", "*.Bat", "Batch File Name", {{"Batch Files","*.Bat"},{"All Files","*.*"}})} ;
                 ;//DC_PopFile( c, nil, "*.BAT", 'Choose A Definition File...', cFileName )} ;
                SAYTOOLTIP "Name Of Batch File"

DCREAD GUI TITLE "Create Batch File" OPTIONS GetOptions ADDBUTTONS FIT ENTEREXIT MODAL SETAPPWINDOW

RETURN cFileName

* -----------

METHOD PathUtil:OpenFile()

LOCAL cFileName, oThread

cFileName := Space(40)

cFileName := DC_PopFile(@cFileName, "", "*.Bat", "Batch File Name", {{"Batch Files","*.Bat"},{"All Files","*.*"}})

IF !Empty(cFileName)
  oThread:=Thread():new()
  oThread:Start( {|| ::ReadFile(cFileName)})
ENDIF

RETURN nil

* -----------

METHOD PathUtil:ReadFile(cFileName)

LOCAL GetList[0], GetOptions
LOCAL cStr, nHndle

cStr := MemoRead(cFileName)

@   0.00,  0.00 DCMULTILINE cStr SIZE 148.30, 20.20 FONT "12.Courier New" TABSTOP ID 'MULTILINE' ;
                EVAL {|o| o:keyboard := DC_MergeBlocks(o:keyboard,{|n,a,o| cStr := o:editBuffer(),DC_GetWhen(GetList) } ) }

@  21.00,  1.00 DCPUSHBUTTONXP  CAPTION "D&one" ;
                ACCELKEY xbeK_ALT_O SIZE 12,1.4 GROUP 'BUTTONS' CONFIG ::ButtonConfig ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
                TOOLTIP "Exit"

@  21.00, 13.00 DCPUSHBUTTONXP  CAPTION "&Save" ;
                ACCELKEY xbeK_ALT_O SIZE 12,1.4 GROUP 'BUTTONS' CONFIG ::ButtonConfig ;
                ACTION {|| FErase(cFileName), ;
                           nHndle := FCreate(cFileName), ;
                           FWrite(nHndle, Alltrim(cStr)), ;
                           FClose(nHndle), ;
                           (DCMSGBOX cFileName+ " Saved!") } ;
                WHEN {|| DC_GetOrigUpdated(GetList, 'MULTILINE')} ;
                TOOLTIP "Save File"

DCREAD GUI TITLE cFileName OPTIONS GetOptions FIT ENTEREXIT MODAL SETAPPWINDOW

RETURN nil

*----------

METHOD PathUtil:DrawCellHighlighted( oPS, aInfo, cHighLight, oFontLarge, oBitmap, nFgColor ) /// OWNERDRAW

LOCAL xData, nPos, nRow, aRect, oCell := aInfo[5], oColumn

IF oCell:isDerivedFrom('DC_MultiLineCellGroup') // It's a header
  RETURN .t.
ENDIF

xData := DC_XtoC(aInfo[ XBP_DRAWINFO_AREA ]:getCell( aInfo[ XBP_DRAWINFO_ITEM ] ))

nRow := aInfo[1]
oColumn := oCell:setParent()

IF nRow == ::browseObject:rowPos
  oPS:setFont(oFontLarge)
ENDIF

IF xData <> nil .AND. ( nPos:= At( cHighlight, xData ) ) > 0

   oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] = XBP_DRAWSTATE_SELECTED, ;
                 XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

   GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                                                     aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

   IF nRow == ::browseObject:rowPos
     oPS:setColor( GRA_CLR_DARKPINK )
   ELSE
     oPS:setColor( GRA_CLR_RED )
   ENDIF

   IF nPos = 1
      GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                     aInfo[ XBP_DRAWINFO_RECT, 4 ] }, cHighlight )
   ELSE
      aRect:= GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

      GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, ;
                          { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, ;
                          cHighlight )
   ENDIF

   RETURN .F.

ELSE

   oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] = XBP_DRAWSTATE_SELECTED, ;
                 XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )


   IF !::browseObject:isEnabled()
     oPS:setColor( nFgColor )
   ELSEIF nRow == ::browseObject:rowPos .AND. ValType(nFgColor) == 'N'
     oPS:setColor( nFgColor )
   ENDIF


   IF nRow == ::browseObject:rowPos .AND. oColumn == ::browseObject:getColumn(1) .AND. Valtype(oBitmap) == 'O'

     aRect:= GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

     oBitmap:draw(oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], ;
                         aInfo[ XBP_DRAWINFO_RECT, 2 ] } )

     GraCaptionStr( oPS,{ aInfo[ XBP_DRAWINFO_RECT, 1 ] + oBitmap:xSize + 2, ;
                          aInfo[ XBP_DRAWINFO_RECT, 2 ] }, ;
                        { aInfo[ XBP_DRAWINFO_RECT, 3 ] + oBitmap:xSize + 2, ;
                          aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

   ELSE

     GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], ;
                        { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                          aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

   ENDIF


   RETURN .f.

ENDIF

RETURN .T.

* ----------

METHOD PathUtil:RClickMenu(oMenuBrow, nColBgn, nColEnd )

LOCAL i
LOCAL oXbp, oCellGroup

DEFAULT nColBgn := 6,;
        nColEnd := 19

FOR i := nColBgn TO nColEnd

   oXbp := ::browseObject:getColumn(i)
   oCellGroup := oXbp:dataArea

   /* -- Attach menu to each cellgroup -- */
   oCellGroup:RbDown := DC_MergeBlocks(oCellGroup:RbDown, ;
                           {|x,y,z|DC_CompleteEvents(), ;
                                   DC_GetRefresh(::getList), ;
                                   oMenuBrow:PopUp ( nil, x, 1 , ;
                           XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )})

NEXT

RETURN nil

* ------------

METHOD PathUtil:FileNames()

LOCAL aNames1[0], aNames2, i
LOCAL cStr

cStr := MemoRead('PathUtil.Txt')
aNames2 := DC_TokenArray(cStr, CHR(13))

ASort(aNames2)

FOR i := 1 TO Len(aNames2)
   IF !Empty(aNames2[i])
     AAdd(aNames1, { aNames2[i], .t. } )
   ENDIF
NEXT


RETURN aNames1

*----------------------------

METHOD PathUtil:Buttonconfig()

LOCAL oConfig

oConfig := DC_XbpPushButtonXPConfig():new()
oConfig:bitmapOffset := 3
oConfig:bitmapScale := .9

oConfig:gradientStep := 8
oConfig:gradientReverse := .F.
oConfig:radius := 8
oConfig:outline := .T.
oConfig:mouseOverScale := 1.2
oConfig:mouseOverFont := '10.Arial Bold Italic'

oConfig:fgColor := GRA_CLR_BLACK
oConfig:bgColor := GraMakeRGBColor({117,186,229})          // BD_BLUESTEEL
oConfig:fgColorMouse := GRA_CLR_WHITE
oConfig:bgColorMouse := GRA_CLR_DARKCYAN
oConfig:fgColorSelected := GRA_CLR_BLACK
oConfig:bgColorSelected := GraMakeRGBColor({113,113,198})  // BD_SLATEBLUE
oConfig:fgColorClick := GRA_CLR_BLACK
oConfig:bgColorClick := GraMakeRGBColor({153,173,174})     // BD_GREYGREEN
oConfig:borderColor := GRA_CLR_BLACK

RETURN oConfig

* -----------

static function _quit()

QUIT

return nil
