// ----------------------------------
// Define Custom Colors
// ----------------------------------

#define BD_BLUEMIST          GraMakeRGBColor({195,238,255})  // BLUE        0001
#define BD_PALETURQUOISE     GraMakeRGBColor({175,238,238})  // BLUE        0002
#define BD_PALEBLUE          GraMakeRGBColor({140,223,255})  // BLUE        0003
#define BD_FADEDBLUE         GraMakeRGBColor({127,222,255})  // BLUE        0004
#define BD_LIGHTBLUESKY      GraMakeRGBColor({135,206,235})  // BLUE        0005
#define BD_ISLANDBLUE        GraMakeRGBColor({053,179,255})  // BLUE        0006
#define BD_DODGERBLUE        GraMakeRGBColor({030,144,255})  // BLUE        0007
#define BD_PASTELBLUE        GraMakeRGBColor({002,131,254})  // BLUE        0008
#define BD_AZURE             GraMakeRGBColor({000,127,255})  // BLUE        0009
#define BD_ROYALBLUE         GraMakeRGBColor({065,105,225})  // BLUE        0010
#define BD_XBP_BLUE          2                               // BLUE        0011
#define BD_RICHBLUE          GraMakeRGBColor({000,000,255})  // BLUE        0012
#define BD_TLCDEEPBLUE       GraMakeRGBColor({000,030,144})  // BLUE        0013
#define BD_NAVYBLUE          GraMakeRGBColor({000,000,128})  // BLUE        0014
#define BD_DARKBLUE          GraMakeRGBColor({000,000,087})  // BLUE        0015
#define BD_MIDNIGHTBLUE      GraMakeRGBColor({025,025,112})  // BLUE        0016
#define BD_NIGHT             GraMakeRGBColor({036,026,068})  // OTHER       0017
#define BD_SKYBLUE           GraMakeRGBColor({209,241,255})  // BLUE        0018
#define BD_ICEBLUE           GraMakeRGBColor({209,253,255})  // BLUE        0019
#define BD_TLCLIGHTBLUE      GraMakeRGBColor({198,255,255})  // BLUE        0020
#define BD_WISPBLUE          GraMakeRGBColor({221,226,255})  // BLUE        0021
#define BD_BLUEHINT          GraMakeRGBColor({208,216,255})  // BLUE        0022
#define BD_LIGHTSTEELBLUE    GraMakeRGBColor({202,225,255})  // BLUE        0023
#define BD_ROCKGREY          GraMakeRGBColor({185,211,238})  // GREY        0024
#define BD_CLEARBLUE         GraMakeRGBColor({156,210,255})  // BLUE        0025
#define BD_BLUESTEEL         GraMakeRGBColor({117,186,229})  // BLUE        0026
#define BD_CORNFLOWERBLUE    GraMakeRGBColor({100,149,237})  // BLUE        0027
#define BD_TLCDARKBLUE       GraMakeRGBColor({075,116,171})  // BLUE        0028
#define BD_TURQUOISE         GraMakeRGBColor({064,244,208})  // BLUE        0029
#define BD_TLCBLUE           GraMakeRGBColor({075,268,200})  // BLUE        0030
#define BD_TEAL              GraMakeRGBColor({014,255,212})  // TEAL        0031
#define BD_AQUAMARINE        GraMakeRGBColor({000,255,232})  // BLUE        0032
#define BD_XBP_CYAN          6                               // CYAN        0033
#define BD_LIGHTBLUE         GraMakeRGBColor({014,240,255})  // BLUE        0034
#define BD_WASHGREEN         GraMakeRGBColor({229,255,228})  // GREEN       0035
#define BD_ICEGREEN          GraMakeRGBColor({222,255,189})  // GREEN       0036
#define BD_GREENFROSTING     GraMakeRGBColor({217,255,179})  // GREEN       0037
#define BD_GREENHINT         GraMakeRGBColor({204,255,191})  // GREEN       0038
#define BD_PALETEAL          GraMakeRGBColor({188,255,211})  // TEAL        0039
#define BD_LIGHTTEAL         GraMakeRGBColor({165,255,210})  // TEAL        0040
#define BD_SEAFOAM           GraMakeRGBColor({135,255,169})  // OTHER       0041
#define BD_PALEGREEN         GraMakeRGBColor({118,255,171})  // GREEN       0042
#define BD_COLDGREEN         GraMakeRGBColor({175,255,127})  // GREEN       0043
#define BD_WISPGREEN         GraMakeRGBColor({175,255,118})  // GREEN       0044
#define BD_ISLANDGREEN       GraMakeRGBColor({135,255,101})  // GREEN       0045
#define BD_PASTELGREEN       GraMakeRGBColor({135,255,000})  // GREEN       0046
#define BD_LAWNGREEN         GraMakeRGBColor({124,252,000})  // GREEN       0047
#define BD_RICHGREEN         GraMakeRGBColor({151,246,096})  // GREEN       0048
#define BD_XBP_GREEN         5                               // GREEN       0049
#define BD_LIGHTGREEN        GraMakeRGBColor({054,255,134})  // GREEN       0050
#define BD_FADEDTEAL         GraMakeRGBColor({103,214,171})  // TEAL        0051
#define BD_BLUEGREY          GraMakeRGBColor({135,183,169})  // BLUE        0052
#define BD_LIGHTSEAGREEN     GraMakeRGBColor({032,178,170})  // GREEN       0053
#define BD_XBP_DARKCYAN      13                              // CYAN        0054
#define BD_CLEARGREEN        GraMakeRGBColor({171,212,159})  // GREEN       0055
#define BD_EARTHGREEN        GraMakeRGBColor({153,173,092})  // GREEN       0056
#define BD_MUDGREEN          GraMakeRGBColor({153,173,000})  // GREEN       0057
#define BD_LEAFYGREEN        GraMakeRGBColor({129,153,040})  // GREEN       0058
#define BD_MONEYLIGHTGREY    GraMakeRGBColor({146,163,127})  // GREEN       0059
#define BD_MONEYLIGHTGREEN   GraMakeRGBColor({126,152,117})  // GREEN       0060
#define BD_ASPARAGUS         GraMakeRGBColor({123,160,091})  // OTHER       0061
#define BD_DANKGREEN         GraMakeRGBColor({077,123,084})  // GREEN       0062
#define BD_MONEYGREENGREY    GraMakeRGBColor({054,084,056})  // GREEN       0063
#define BD_MONEYGREEN        GraMakeRGBColor({024,050,021})  // GREEN       0064
#define BD_CHARTREUSE        GraMakeRGBColor({113,198,113})  // TEAL        0065
#define BD_EMERALDGREEN      GraMakeRGBColor({081,200,120})  // GREEN       0066
#define BD_DEEPGREEN         GraMakeRGBColor({054,194,114})  // GREEN       0067
#define BD_FORESTGREEN       GraMakeRGBColor({034,139,034})  // GREEN       0068
#define BD_SEAGREEN          GraMakeRGBColor({046,139,087})  // GREEN       0069
#define BD_DARKGREEN         GraMakeRGBColor({000,100,000})  // GREEN       0070
#define BD_BISQUE            GraMakeRGBColor({255,228,196})  // OTHER       0071
#define BD_ANTIQUEWHITE      GraMakeRGBColor({250,235,215})  // OTHER       0072
#define BD_BONE              GraMakeRGBColor({249,246,210})  // OTHER       0073
#define BD_PEACH             GraMakeRGBColor({255,230,188})  // OTHER       0074
#define BD_PALEGOLDENROD     GraMakeRGBColor({238,232,170})  // OTHER       0075
#define BD_LIGHTGOLDENROD    GraMakeRGBColor({238,221,130})  // OTHER       0076
#define BD_BANANA            GraMakeRGBColor({227,207,087})  // OTHER       0077
#define BD_BURLYWOOD         GraMakeRGBColor({222,184,135})  // OTHER       0078
#define BD_PERU              GraMakeRGBColor({205,133,063})  // OTHER       0079
#define BD_COPPER            GraMakeRGBColor({184,115,051})  // OTHER       0080
#define BD_BROWN             GraMakeRGBColor({150,075,000})  // OTHER       0081
#define BD_MILKCHOCOLATE     GraMakeRGBColor({112,046,000})  // OTHER       0082
#define BD_AUBURN            GraMakeRGBColor({113,047,044})  // OTHER       0083
#define BD_CHOCOLATE         GraMakeRGBColor({068,000,000})  // OTHER       0084
#define BD_DARKWHEAT         GraMakeRGBColor({205,186,150})  // OTHER       0085
#define BD_DARKERWHEAT       GraMakeRGBColor({194,182,133})  // OTHER       0086
#define BD_LAZYGREEN         GraMakeRGBColor({204,210,158})  // GREEN       0087
#define BD_ECRU              GraMakeRGBColor({178,188,121})  // OTHER       0088
#define BD_FATIGUES          GraMakeRGBColor({153,173,109})  // OTHER       0089
#define BD_BRASS             GraMakeRGBColor({181,166,066})  // OTHER       0090
#define BD_GOLDENROD         GraMakeRGBColor({218,165,032})  // OTHER       0091
#define BD_DARKGOLDENROD     GraMakeRGBColor({184,134,011})  // OTHER       0092
#define BD_LIGHTCORAL        GraMakeRGBColor({240,128,128})  // OTHER       0093
#define BD_LIGHTSALMON       GraMakeRGBColor({255,160,122})  // OTHER       0094
#define BD_KHAKI             GraMakeRGBColor({189,183,107})  // OTHER       0095
#define BD_DARKKHAKI         GraMakeRGBColor({197,185,115})  // OTHER       0096
#define BD_CLOUD             GraMakeRGBColor({245,245,240})  // OTHER       0097
#define BD_IVORY             GraMakeRGBColor({252,246,229})  // OTHER       0098
#define BD_LINEN             GraMakeRGBColor({253,240,230})  // OTHER       0099
#define BD_LEMONCREME        GraMakeRGBColor({255,250,205})  // OTHER       0100
#define BD_CREME             GraMakeRGBColor({249,246,189})  // TAN         0101
#define BD_EGGSHELL          GraMakeRGBColor({252,230,201})  // OTHER       0102
#define BD_CORNSILK          GraMakeRGBColor({238,232,205})  // OTHER       0103
#define BD_SAND              GraMakeRGBColor({232,228,216})  // OTHER       0104
#define BD_KEYLIME           GraMakeRGBColor({175,246,084})  // OTHER       0105
#define BD_LIME              GraMakeRGBColor({153,235,000})  // OTHER       0106
#define BD_RICHLIME          GraMakeRGBColor({087,255,000})  // OTHER       0107
#define BD_MAGENTA           GraMakeRGBColor({205,000,205})  // OTHER       0108
#define BD_EGGPLANT          GraMakeRGBColor({153,000,102})  // OTHER       0109
#define BD_MAROON            GraMakeRGBColor({139,028,098})  // OTHER       0110
#define BD_MANGO             GraMakeRGBColor({255,091,039})  // OTHER       0111
#define BD_SANDYBROWN        GraMakeRGBColor({244,164,096})  // OTHER       0112
#define BD_SUNSET            GraMakeRGBColor({245,160,014})  // OTHER       0113
#define BD_MANGOCREME        GraMakeRGBColor({255,129,063})  // OTHER       0114
#define BD_SALMON            GraMakeRGBColor({250,128,114})  // OTHER       0115
#define BD_MISTYROSE         GraMakeRGBColor({255,228,225})  // OTHER       0116
#define BD_MOSS              GraMakeRGBColor({200,201,001})  // OTHER       0117
#define BD_OFFWHITE          GraMakeRGBColor({255,255,235})  // OTHER       0118
#define BD_PINKSAND          GraMakeRGBColor({255,204,220})  // OTHER       0119
#define BD_PINKROSE          GraMakeRGBColor({255,184,255})  // OTHER       0120
#define BD_ORCHID            GraMakeRGBColor({218,112,214})  // OTHER       0121
#define BD_FUSHIA            GraMakeRGBColor({193,084,193})  // OTHER       0122
#define BD_INDIGO            GraMakeRGBColor({075,000,130})  // OTHER       0123
#define BD_PINEBARK          GraMakeRGBColor({167,158,125})  // OTHER       0124
#define BD_SANDSTONE         GraMakeRGBColor({204,204,153})  // OTHER       0125
#define BD_SANDYCORAL        GraMakeRGBColor({214,213,189})  // OTHER       0126
#define BD_JOURNALGREEN      GraMakeRGBColor({220,232,210})  // GREEN       0127
#define BD_SEASHELL          GraMakeRGBColor({255,245,238})  // OTHER       0128
#define BD_SNOW              GraMakeRGBColor({255,250,255})  // OTHER       0129
#define BD_WHEAT             GraMakeRGBColor({245,222,179})  // OTHER       0130
#define BD_PALEDESSERT       GraMakeRGBColor({223,211,183})  // TAN         0131
#define BD_LIGHTDESSERT      GraMakeRGBColor({211,202,170})  // TAN         0132
#define BD_DESSERT           GraMakeRGBColor({211,202,183})  // TAN         0133
#define BD_FADEDDESSERT      GraMakeRGBColor({211,202,193})  // TAN         0134
#define BD_XBP_PALEGRAY      15                              // GREY        0135
#define BD_SILVER            GraMakeRGBColor({192,192,192})  // OTHER       0136
#define BD_BRIGHTGREY        GraMakeRGBColor({197,193,170})  // GREY        0137
#define BD_GREY              GraMakeRGBColor({188,188,176})  // GREY        0138
#define BD_LIGHTGREY         GraMakeRGBColor({230,231,232})  // GREY        0139
#define BD_ICEGREY           GraMakeRGBColor({236,242,234})  // GREY        0140
#define BD_INVOICEGREY       GraMakeRGBColor({239,233,228})  // GREY        0141
#define BD_MICROSOFTGREY     GraMakeRGBColor({224,223,227})  // GREY        0142
#define BD_DEFAULTGREY       GraMakeRGBColor({212,208,200})  // GREY        0143
#define BD_WASHGREY          GraMakeRGBColor({210,210,210})  // GREY        0144
#define BD_HEADERGREY        GraMakeRGBColor({216,228,231})  // GREY        0145
#define BD_SLATEGREY         GraMakeRGBColor({158,182,205})  // GREY        0146
#define BD_SILVERBLUE        GraMakeRGBColor({131,156,165})  // OTHER       0147
#define BD_GREYGREEN         GraMakeRGBColor({153,173,174})  // GREY        0148
#define BD_DARKGREY          GraMakeRGBColor({090,091,080})  // GREY        0149
#define BD_DULLGREY          GraMakeRGBColor({087,091,090})  // GREY        0150
#define BD_FRAMEGREY         GraMakeRGBColor({148,148,148})  // GREY        0151
#define BD_LINEGREY          GraMakeRGBColor({128,128,128})  // GREY        0152
#define BD_CREMESICLE        GraMakeRGBColor({239,246,121})  // TAN         0153
#define BD_FADEDGOLD         GraMakeRGBColor({255,227,109})  // GOLD        0154
#define BD_LIGHTGOLD         GraMakeRGBColor({255,227,000})  // GOLD        0155
#define BD_GOLD              GraMakeRGBColor({255,217,000})  // GOLD        0156
#define BD_TLCGOLD           GraMakeRGBColor({255,197,000})  // GOLD        0157
#define BD_ORANGE            GraMakeRGBColor({255,160,000})  // ORANGE      0158
#define BD_ORANGEPEEL        GraMakeRGBColor({255,126,003})  // ORANGE      0159
#define BD_BURNTORANGE       GraMakeRGBColor({204,085,000})  // ORANGE      0160
#define BD_LIGHTORANGE       GraMakeRGBColor({255,180,000})  // ORANGE      0161
#define BD_PALEORANGE        GraMakeRGBColor({255,156,000})  // ORANGE      0162
#define BD_TAN               GraMakeRGBColor({244,226,171})  // TAN         0163
#define BD_LIGHTTAN          GraMakeRGBColor({244,225,199})  // TAN         0164
#define BD_DARKTAN           GraMakeRGBColor({234,215,180})  // TAN         0249
#define BD_PALEYELLOW        GraMakeRGBColor({255,255,210})  // YELLOW      0165
#define BD_FLATYELLOW        GraMakeRGBColor({255,255,193})  // YELLOW      0166
#define BD_FADEDYELLOW       GraMakeRGBColor({255,255,185})  // YELLOW      0167
#define BD_HINTYELLOW        GraMakeRGBColor({255,255,153})  // YELLOW      0168
#define BD_LIGHTYELLOW       GraMakeRGBColor({255,255,130})  // YELLOW      0169
#define BD_YELLOW            GraMakeRGBColor({255,229,053})  // YELLOW      0170
#define BD_SUNNYYELLOW       GraMakeRGBColor({255,255,000})  // YELLOW      0171
#define BD_DEEPYELLOW        GraMakeRGBColor({216,189,000})  // YELLOW      0172
#define BD_DARKYELLOW        GraMakeRGBColor({196,179,000})  // YELLOW      0173
#define BD_OLIVEDRAB         GraMakeRGBColor({142,142,056})  // GREEN       0174
#define BD_XBP_BROWN         14                              // TAN         0175
#define BD_PINKCOTTON        GraMakeRGBColor({255,215,255})  // PINK        0176
#define BD_PUFFINK           GraMakeRGBColor({241,185,213})  // PINK        0177
#define BD_PALEPURPLE        GraMakeRGBColor({231,160,226})  // PURPLE      0178
#define BD_LIGHTPURPLE       GraMakeRGBColor({210,152,206})  // PURPLE      0179
#define BD_FUCHSIA           GraMakeRGBColor({229,070,183})  // PINK        0180
#define BD_HOTPINK           GraMakeRGBColor({229,070,129})  // PINK        0181
#define BD_XBP_PINK          4                               // PINK        0182
#define BD_XBP_DARKPINK      11                              // PINK        0183
#define BD_REDHINT           GraMakeRGBColor({255,213,231})  // RED         0184
#define BD_LAZYPURPLE        GraMakeRGBColor({248,201,245})  // PURPLE      0185
#define BD_WISPRED           GraMakeRGBColor({239,195,228})  // RED         0186
#define BD_FADEDPURPLE       GraMakeRGBColor({241,187,241})  // PURPLE      0187
#define BD_COTTONCANDYRED    GraMakeRGBColor({255,147,156})  // RED         0188
#define BD_PALERED           GraMakeRGBColor({255,147,156})  // RED         0189
#define BD_DEEPRED           GraMakeRGBColor({229,070,097})  // RED         0190
#define BD_RED               3                               // RED         0191
#define BD_CANDYRED          GraMakeRGBColor({255,000,000})  // RED         0192
#define BD_LIGHTRED          GraMakeRGBColor({255,050,039})  // RED         0193
#define BD_DARKRED           GraMakeRGBColor({168,000,000})  // RED         0194
#define BD_CRIMSON           GraMakeRGBColor({220,020,060})  // RED         0195
#define BD_INDIANRED         GraMakeRGBColor({176,023,031})  // RED         0196
#define BD_LAVENDER          GraMakeRGBColor({230,230,250})  // OTHER       0197
#define BD_PURPLEHINT        GraMakeRGBColor({207,211,255})  // PURPLE      0198
#define BD_COOLPURPLE        GraMakeRGBColor({209,198,255})  // PURPLE      0199
#define BD_PURPLE            GraMakeRGBColor({188,151,255})  // PURPLE      0200
#define BD_GRAPE             GraMakeRGBColor({135,116,169})  // OTHER       0201
#define BD_SLATEBLUE         GraMakeRGBColor({113,113,198})  // BLUE        0202
#define BD_FLATPURPLE        GraMakeRGBColor({135,097,169})  // PURPLE      0203
#define BD_AMETHYST          GraMakeRGBColor({153,102,204})  // OTHER       0204
#define BD_SIENNA            GraMakeRGBColor({160,082,452})  // OTHER       0205
#define BD_BLUEVIOLET        GraMakeRGBColor({138,043,226})  // BLUE        0206
#define BD_BRIGHTPURPLE      GraMakeRGBColor({112,046,253})  // PURPLE      0207
#define BD_DEEPPURPLE        GraMakeRGBColor({117,007,229})  // PURPLE      0208
#define BD_BEET              GraMakeRGBColor({142,056,142})  // PURPLE      0209
#define BD_TINTEDPURPLE      GraMakeRGBColor({112,045,107})  // PURPLE      0210
#define BD_RICHPURPLE        GraMakeRGBColor({168,045,119})  // PURPLE      0211
#define BD_OUTLOOKBUTT       GraMakeRGBColor({236,233,216})  // OTHER       0212
#define BD_OUTLOOKBGD        GraMakeRGBColor({227,239,255})  // OTHER       0213
#define BD_OUTLOOKRIBDARK    GraMakeRGBColor({166,188,217})  // OTHER       0214
#define BD_OUTLOOKRIBLIGHT   GraMakeRGBColor({191,219,255})  // OTHER       0215
#define BD_OUTLOOKMARGIN     GraMakeRGBColor({101,147,207})  // OTHER       0216
#define BD_SMSBGD            GraMakeRGBColor({197,231,183})  // OTHER       0217
#define BD_SMSRIBDARK        GraMakeRGBColor({103,195,071})  // OTHER       0218
#define BD_SMSRIBLIGHT       GraMakeRGBColor({174,224,159})  // OTHER       0219
#define BD_SMSRIBMARGIN      GraMakeRGBColor({062,147,104})  // OTHER       0220
#define BD_TRUE              -4                              // AAA         0221
#define BD_DIMWHITE          GraMakeRGBColor({250,250,250})  // AAA         0222
#define BD_WHITE             0                               // AAA         0223
#define BD_BACKGROUND        -2                              // AAA         0224
#define BD_BLACK             1                               // AAA         0225
#define BD_NEUTRAL           -1                              // AAA         0226
#define BD_FALSE             -5                              // AAA         0227
#define BD_OUTLINE           0                               // AAA         0228
#define BD_LEDGEROFFWHITE1   GraMakeRGBColor({250,252,246})  // OTHER       0229
#define BD_LEDGEROFFWHITE2   GraMakeRGBColor({245,244,234})  // OTHER       0230
#define BD_LEDGERGREY1       GraMakeRGBColor({233,244,255})  // BLUE        0231
#define BD_LEDGERGREY2       GraMakeRGBColor({216,235,241})  // BLUE        0232
#define BD_LEDGERGREY3       GraMakeRGBColor({234,237,244})  // BLUEGREY    0233
#define BD_LEDGERGREY4       GraMakeRGBColor({211,221,233})  // BLUEGREY    0234
#define BD_LEDGER            GraMakeRGBColor({152,255,153})  // GREEN       0235
#define BD_LEDGERGREEN1      GraMakeRGBColor({225,255,225})  // GREEN       0236
#define BD_LEDGERGREEN2      GraMakeRGBColor({213,232,230})  // GREEN       0237
#define BD_LEDGERGREEN3      GraMakeRGBColor({236,240,223})  // GREEN       0238
#define BD_LEDGERGREEN4      GraMakeRGBColor({216,228,188})  // GREEN       0239
#define BD_LEDGERGREEN5      GraMakeRGBColor({235,232,177})  // GREEN       0240
#define BD_LEDGERGREEN6      GraMakeRGBColor({225,222,130})  // 0244        0241
#define BD_LEDGERRED1        GraMakeRGBColor({255,236,239})  // RED         0242
#define BD_LEDGERRED2        GraMakeRGBColor({244,220,245})  // RED         0243
#define BD_LEDGERYELLOW1     GraMakeRGBColor({248,231,160})  // YELLOW      0244
#define BD_LEDGERYELLOW2     GraMakeRGBColor({238,221,150})  // YELLOW      0245
#define BD_LEDGERTAN1        GraMakeRGBColor({242,234,211})  // TAN         0246
#define BD_LEDGERTAN2        GraMakeRGBColor({230,220,200})  // TAN         0247
#define BD_LEDGERBLUE1       GraMakeRGBColor({221,238,255})  // BLUE        0248
#define BD_LEDGERBLUE2       GraMakeRGBColor({231,248,255})  // BLUE        0249

// ----------------------------------
// End Custom Colors
// ----------------------------------

